Attribute VB_Name = "basWordDocs"
Option Explicit

Sub ChooseTemplate()
'Written by Helen Feddema 11-21-99
'Last modified 11-21-99

On Error GoTo ErrorHandler

   'Display UserForm to select a Word template
   Load frmChooseTemplate
   frmChooseTemplate.Show
   
ErrorHandlerExit:
   Exit Sub

ErrorHandler:
   MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
   Resume ErrorHandlerExit

End Sub

Function GenerateDocs(strWordTemplate As String)
'Written by Helen Feddema 11-20-99
'Last modified 9-2-2000

On Error GoTo ErrorHandler

   Dim nms As NameSpace
   Dim fld As MAPIFolder
   Dim itms As Items
   Dim itm As Object
   Dim exp As Explorer
   Dim sel As Outlook.Selection
   Dim strDocsPath As String
   Dim strTemplatePath As String
   Dim appWord As Word.Application
   Dim docs As Word.Documents
   Dim strShortDate As String
   Dim strLongDate As String
   Dim strAddress As String
   Dim strTest As String
   Dim strName As String
   Dim strSalutation As String
   Dim strJobTitle As String
   Dim strCompanyName As String
   Dim strSaveName As String
   Dim fso As FileSystemObject
   Dim prps As Object
   Dim strDocType As String
   Dim lngSelectionCount
   
   'Set a reference to the currently selected folder
   Set nms = Application.GetNamespace("MAPI")
   Set exp = Application.ActiveExplorer
   Set fld = exp.CurrentFolder
   Debug.Print "Folder default item type: " & fld.DefaultItemType
   
   If fld.DefaultItemType <> olContactItem Then
      MsgBox "Folder does not contain contact items; exiting"
      Exit Function
   End If
   
   Set sel = exp.Selection
   lngSelectionCount = sel.Count
   Debug.Print "Number of selected contacts: " & lngSelectionCount
   
   If lngSelectionCount = 0 Then
      MsgBox "No contact items selected; exiting:"
      Exit Function
   End If
   
   'Open Word invisibly
   Set appWord = GetObject(, "Word.Application")

   
   strDocsPath = appWord.Options.DefaultFilePath(wdDocumentsPath) & "\"
   Debug.Print "Docs path: " & strDocsPath
   strTemplatePath = appWord.Options.DefaultFilePath(wdUserTemplatesPath) & "\"
   Debug.Print "Template Path: " & strTemplatePath
   strWordTemplate = strTemplatePath & strWordTemplate
   Debug.Print "Selected template: " & strWordTemplate

   'Check for existence of template in template folder,
   'and exit if not found
   Set fso = CreateObject("Scripting.FileSystemObject")
   strTest = fso.GetFile(strWordTemplate)
   If strTest = "" Then
      MsgBox "Word template not found in " & strTemplatePath & _
         "; exiting"
      Exit Function
   End If
   
   strShortDate = Format(Date, "m-d-yyyy")
   strLongDate = Format(Date, "Long Date")

   For Each itm In sel
      If itm.Class = olContact Then
         'Create a letter for the selected contact
         'Check for required address information
         strName = Nz(itm.FirstName) & Chr(32) & Nz(itm.LastName)
         Debug.Print "Name: " & strName
         strAddress = Nz(itm.BusinessAddress)
         If strAddress = "" Then
            MsgBox "Can't send letter to " & strName & " -- no address!"
            GoTo NextItem
         End If
         
         strJobTitle = Nz(itm.JobTitle)
         If strJobTitle <> "" Then
            strName = strName & vbCrLf & strJobTitle
         End If
      
         If Nz(itm.NickName) = "" And Nz(itm.Title) = "" Then
            strSalutation = "Sir"
         Else
               strSalutation = Nz(itm.Title) & Chr(32) & Nz(itm.LastName)
         End If
         Debug.Print "Salutation: " & strSalutation
      
         strCompanyName = Nz(itm.CompanyName)
         Debug.Print "Company name: " & strCompanyName
         If strCompanyName <> "" Then
            'Concatenate CompanyName with Address if CompanyName is not null
            strAddress = strCompanyName & vbCrLf & strAddress
         End If
         
         'Open a new letter based on the selected template
         appWord.Documents.add strWordTemplate
         
         'Write information to Word custom document properties
         Set prps = appWord.ActiveDocument.CustomDocumentProperties
         With prps
            .Item("Name").Value = strName
            .Item("Salutation").Value = strSalutation
            .Item("Address").Value = strAddress
            .Item("TodayDate").Value = strLongDate
         End With
         
         strDocType = appWord.ActiveDocument.BuiltInDocumentProperties(2)
         strSaveName = strDocType & " to " & itm.FirstName & " " & itm.LastName
         strSaveName = strSaveName & " on " & strShortDate & ".doc"
         strSaveName = strDocsPath & strSaveName
         Debug.Print "Save name: " & strSaveName
      
         'Update fields in Word document and activate it
         With appWord
            .Selection.WholeStory
            .Selection.Fields.Update
            .Selection.HomeKey unit:=wdStory
            .ActiveDocument.SaveAs strSaveName
            .ActiveWindow.WindowState = wdWindowStateNormal
            .Visible = True
            .Activate
         End With
      End If
NextItem:
   Next itm

ErrorHandlerExit:
   Exit Function

ErrorHandler:
   If Err = 429 Then
      'Word is not running; open Word with CreateObject
      Set appWord = CreateObject("Word.Application")
      Resume Next
   Else
      MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
      Resume ErrorHandlerExit
   End If

End Function


